package com.aliyun.chatbot.channel.chatbot;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.annotation.JSONField;

import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

/**
 * @author kelin
 * @date 2024/2/23
 */
@Data
public class ChatbotSSERequest {
    @JSONField(name = "messageId")
    private String messageId = UUID.randomUUID().toString();

    @JSONField(name = "action")
    private String action = "TongyiBeebotChat";

    @JSONField(name = "version")
    private String version = "2022-04-08";

    @JSONField(name = "data")
    private List<DataItem> data;

    @Data
    @NoArgsConstructor
    public static class DataItem {
        @JSONField(name = "type")
        private String type = "JSON_TEXT";

        @JSONField(name = "value")
        private String value;

        public DataItem(String value) {
            this.value = value;
        }
    }

    @Data
    @Accessors(chain = true)
    public static class UtteranceData {
        @JSONField(name = "InstanceId")
        private String instanceId;
        @JSONField(name = "Utterance")
        private String utterance;
        @JSONField(name = "SessionId")
        private String sessionId;

    }

    public static ChatbotSSERequest build(String instanceId, String utterance, String sessionId) {
        ChatbotSSERequest sseChatRequest = new ChatbotSSERequest();
        UtteranceData utteranceData = new UtteranceData()
            .setUtterance(utterance)
            .setInstanceId(instanceId)
            .setSessionId(sessionId);

        sseChatRequest.setData(Arrays.asList(new DataItem(JSON.toJSONString(utteranceData))));

        return sseChatRequest;
    }
}
